# -*- coding: utf-8 -*-
#
#       simulador.py
#       
#       Copyright 2011 Gonzalo <hqzubzero@gmail.com>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#       
#       

import random

### funciones basicas ###

def pregunta( preg, tipo):
    while True:
        print preg
        res = raw_input(":")
        try:
            res = tipo(res)
            return res
        except:
            print u"Escribe algo ", tipo

def pregunta_op_mult( preg, num_op):
    print preg
    while True:
        res = raw_input(": ")
        try:
            res = int(res)
        except:
            print u"Usa enteros"
        if res in num_op:
            return res
        else:
            print u"Usa un numero en: ", str(num_op)

def pregunta_sn(preg):
    while True:
        print preg
        res = raw_input("[s/n]: ")
        if res in ["S","s"]:
            return "s"
        if res in ["N","n"]:
            return "n"
        else:
            print u'Responde "s" o "n" '

def max_lis_key(lista):
    bueno = lista[0]
    i = 0
    res = 0
    for x in lista:
        if x > bueno:
            res = i
            bueno = x
        i = i+1
    return res

### objetos ###

class partido(object):
    nom = 0
    def __init__(self, opinion, name):
        self.opinion = opinion
        self.name = str(name)
        self.numero = partido.nom
        partido.nom = partido.nom + 1
    def __str__(self):
        return self.name

#class Opinion(object):
#    def __init__(self,name):
#        self.name = name


class boleta(object):
    def __init__(self, opinions, partidos):
        self.opinions = opinions
        self.partidos = partidos


class votante(object):
    nom = 1
    def __init__(self, opinion, voto_estr, voto_free):
        self.name = votante.nom
        self.opinion = opinion
        self.voto_free = voto_free
        self.voto_estr = voto_estr
        votante.nom = votante.nom + 1

# Opinions es una lista que va del 0 al n, originalmente cada partido tendria una opinion, 
# y varios partidos podrian tener la misma opinion, cambiare eso ahora cada partido tendra solo una opinion
        
def votante_total_al(opinions, partidos):
    voto_free = []
    for partido in partidos:
        voto_free.append(0)
    sig_punt =  len(partidos) -1
    al_part = range(len(partidos))
    random.shuffle(al_part)
    cnt = 0
    for par_ind in al_part:
        voto_free[par_ind] = random.choice([ sig_punt, 0] )
        if voto_free[par_ind] == sig_punt:
            sig_punt = sig_punt - 1
        if cnt == len(partidos)-1 and sig_punt ==  len(partidos) -1:
            voto_free[par_ind] = sig_punt
            sig_punt = sig_punt - 1
        cnt = cnt +1
    if sig_punt <= 0:
        return votante(opinions[0], voto_free, voto_free)
    quedan = range(sig_punt + 1)
    random.shuffle(quedan)
    voto_estr = []
    for puntos in voto_free:
        voto_estr.append(puntos)
    i=0
    j=0
    for puntos in voto_estr:
        if puntos == 0:
            voto_estr[j] = quedan[i]
            i = i+1
        j = j+1
    return votante(opinions[0], voto_estr, voto_free)

def votar_con_op(opinion, opinions, partidos, razon):
    """Esta funcion debe devover una lista con dos listas una del voto estricto y la otra con el voto libre.
    La opinion sera un entero entre de 0 a len(opinios)-1.
    Las opiniones seran las opiniones.
    Y la razon es un numero entre 0 y 1 que indicara cuanto baja la probabilidad de """
    voto_free = []
    for partido in partidos:
        voto_free.append(0)
    partidos_c = []
    for par in partidos:
        partidos_c.append(par)
    random.shuffle(partidos_c)
    sig_punt = len(partidos_c)-1
    for par in partidos_c:
        k = 1 - (abs(par.opinion - opinion) * razon)
        r = random.random()
        if r < k:
            voto_free[par.numero] = sig_punt
            sig_punt = sig_punt - 1
    if sig_punt <= 0:
        return [voto_free, voto_free]
    quedan = range(sig_punt + 1)
    random.shuffle(quedan)
    voto_estr = []
    for puntos in voto_free:
        voto_estr.append(puntos)
    i=0
    j=0
    for puntos in voto_estr:
        if puntos == 0:
            voto_estr[j] = quedan[i]
            i = i+1
        j = j+1
    return [voto_estr, voto_free]

def votar_con_op_buena(opinion, opinions, partidos, lim):
    voto_estr = []
    voto_free = []
    partidos_c = []
    for par in partidos:
        voto_estr.append(0)
        voto_free.append(0)
        partidos_c.append(par)
    random.shuffle(partidos_c)
    orden = []
    for o in opinions:
        orden.append(0)
    for parti in partidos_c:
        dis = abs(opinion - parti.opinion)
        end = 0
        while end == 0:
            if orden[dis] == 0:
                orden[dis] = parti
                end = 1
            else:
                dis = dis + 1
    h_orden = []
    for i in orden:
        if not(i == 0):
            h_orden.append(i)
    sig_punt= len(partidos)-1
    for parti in h_orden:
        try:
            voto_estr[parti.numero] = sig_punt
            sig_punt = sig_punt - 1
        except:
            print "error raro"
            print parti.numero
            print voto_estr
            raw_input("?")
    cnt = 0
    for puntos in voto_estr:
        if puntos > lim:
            voto_free[cnt] = puntos
        cnt = cnt + 1
    return [voto_estr,voto_free]

def crear_votante_op(opinions, opinion, partidos, razon):
    votos = votar_con_op(opinion, opinions, partidos, razon)
    return votante(opinion, votos[0], votos[1])

def crear_votante_op_buena(opinions, opinion, partidos, lim):
    votos = votar_con_op_buena(opinion, opinions, partidos, lim)
    return votante(opinion, votos[0], votos[1])


######################## Metodos de escrutinio

def eleccion_mexi(votantes):
    bingo = len(votantes[0].voto_estr)-1
    res = []
    for i in votantes[0].voto_estr:
        res.append(0)
    for votante in votantes:
        cnt = 0
        for n in votante.voto_estr:
            if n == bingo:
                res[cnt] = res[cnt] + 1
            cnt = cnt + 1
    return res

def metodo_borda(votantes):
    res = []
    for i in votantes[0].voto_estr:
        res.append(0)
    for votante in votantes:
        cnt = 0
        for voto in votante.voto_estr:
            res[cnt] = res[cnt] + voto
            cnt = cnt + 1
    return res

def metodo_borda_exp(votantes):
    res = []
    for i in votantes[0].voto_estr:
        res.append(0)
    for votante in votantes:
        cnt = 0
        for voto in votante.voto_estr:
            res[cnt] = res[cnt] + 2**voto
            cnt = cnt + 1
    return res


def mi_eleccion_1(votantes):
    res = []
    for i in votantes[0].voto_estr:
        res.append(0)
    for votante in votantes:
        cnt = 0
        for voto in votante.voto_free:
            res[cnt] = res[cnt] + voto
            cnt = cnt + 1
    return res

def mi_eleccion_2(votantes):
    res = []
    for i in votantes[0].voto_estr:
        res.append(0)
    for votante in votantes:
        cnt = 0
        for voto in votante.voto_free:
            res[cnt] = res[cnt] + 2**voto
            cnt = cnt + 1
    return res

def eleccion_grafi(votantes):
    res = {}
    for k in range(len(votantes[0].voto_estr)):
        res[k] = []
    for i in range(len(votantes[0].voto_estr)):
        for j in range(i+1,len(votantes[0].voto_estr)):
            res_ij = [0,0]
            for votante in votantes:
                if votante.voto_estr[i] > votante.voto_estr[j]:
                    res_ij[0] = res_ij[0] + 1
                else:
                    res_ij[1] = res_ij[1] + 1
            if res_ij[0] > res_ij[1]:
                res[i].append(j)
            if res_ij[1] > res_ij[0]:
                res[j].append(i)
    return res

def resultado_grafica(grafi):
    ganador = "No se pudo determinar"
    req = len(grafi.keys())-1
    for i in grafi.keys():
        if len(grafi[i]) == req:
            ganador = i
    return ganador


def grafi_gan_intran(grafi):
    """tomando un digrafo (dict) devuelve una terna, True en el lugar 0 de la terna significa que hubo un ganador, True en el lugar 1 significa que no hubo ciclos, y el tercer lugar dice quien fue el ganador de haberlo"""
    res = []
    gan = resultado_grafica(grafi)
    if type(resultado_grafica(grafi)) == str:
        res = [False,False, None]
        return res
    else:
        for punto in grafi.keys():
            if type(resultado_grafica(grafi)) == int:
                del grafi[resultado_grafica(grafi)]
            else:
                return [True,False,gan]
    return [True,True, gan]
    
        


################################# Funciones para la simulacion

def has_opinions():
    res = pregunta(u"¿cuantas opiniones quieres?", int )
    return range(res +1)

def has_partidos(opinions):
    res =[]
    num_par = pregunta(u"¿cuantos partidos quieres?", int)
    opinionsc = []
    for opi in opinions:
        opinionsc.append(opi)
    for num in xrange(num_par):
        er = 1
        while er == 1:
            print "Partido num", num
            op = pregunta(u"¿que opinión tendra? ", int)
            try:
                opinionsc.remove(op)
                nombre = ""
                if nombre == "":
                    nombre = num
                res.append(partido(op, nombre))
                er = 0
            except:
                print u"Esa opinion ya fue tomada o no esta disponible"
    return res

def has_partidos_nom(opinions):
    res =[]
    num_par = pregunta(u"¿cuantos partidos quieres?", int)
    opinionsc = []
    for opi in opinions:
        opinionsc.append(opi)
    for num in xrange(num_par):
        er = 1
        while er == 1:
            print "Partido num", num
            op = pregunta(u"¿que opinión tendra? ", int)
            try:
                opinionsc.remove(op)
                nombre = pregunta( u"¿Nombre del partido?", str)
                if nombre == "":
                    nombre = num
                res.append(partido(op, nombre))
                er = 0
            except:
                print u"Esa opinion ya fue tomada o no esta disponible"
    return res


def has_partidos_para_al():
    res =[]
    num_par = pregunta(u"¿cuantos partidos quieres?", int)
    for num in xrange(num_par):
        print "Partido num", num
        op = num
        nombre = ""
        if nombre == "":
            nombre = num
        res.append(partido(op, nombre))
    return res

def has_partidos_para_al_nom():
    res =[]
    num_par = pregunta(u"¿cuantos partidos quieres?", int)
    for num in xrange(num_par):
        print "Partido num", num
        op = num
        nombre = pregunta( u"¿Nombre del partido?", str)
        if nombre == "":
            nombre = num
        res.append(partido(op, nombre))
    return res


def has_partidos_para_al_auto():
    num = pregunta(u"¿Cuantos partidos quieres?", int)
    res = []
    for i in xrange(num):
        res.append(partido(i,i))
    return res

def n_votantes_al(numero, opinions, partidos):
    res = []
    for i in xrange(numero):
        res.append(votante_total_al(opinions,partidos))
    return res

def n_votantes_op(numero, opinion, opinions, partidos, razon):
    res = []
    for i in xrange(numero):
        res.append(crear_votante_op(opinions, opinion, partidos, razon))
    return res


def probar(partidos):
    a = crear_votante_op(range(11), 1, partidos, 0.2)
    print a.voto_estr
    print a.voto_free

def votantes_contentos(votantes, partido_gan, puntos_min):
    res = 0
    for votante in votantes:
        if votante.voto_free[partido_gan] >= puntos_min :
            res = res +1
    return res

def presentar_resultados_list(resultados, partidos):
    i = 0
    for x in resultados:
        print u"el partido: ", partidos[i], u" tuvo ", resultados[i]
        i = i+1
    print u"Ganó el partido ", partidos[max_lis_key(resultados)]
    return max_lis_key(resultados)


def imprime_resultados(votantes,partidos):
    ans = pregunta_sn(u"¿Imprimir votos?")
    if ans == "s":
        for votant in votantes:
            print votant.voto_estr, votant.voto_free
    print u"===== Resultados de elección Mexicana===="
    resultados0 = eleccion_mexi(votantes)
    gan0 = presentar_resultados_list(resultados0, partidos)
    print "hay ", votantes_contentos(votantes, gan0, (len(partidos))/2 ), u"votantes contentos"
    raw_input()

    print u"===== Resultados de metodo Borda ====="
    resultados4 = metodo_borda(votantes)
    gan4 = presentar_resultados_list(resultados4, partidos)
    print "hay ", votantes_contentos(votantes, gan4, (len(partidos))/2 ), u"votantes contentos"
    raw_input()    

    print u"===== Resultados de metodo Borda con Exp ====="
    resultados5 = metodo_borda_exp(votantes)
    gan5 = presentar_resultados_list(resultados5, partidos)
    print "hay ", votantes_contentos(votantes, gan5, (len(partidos))/2 ), u"votantes contentos"
    raw_input()

    print u"===== Resultados de metodo Borda Modificado ====="
    resultados1 = mi_eleccion_1(votantes)
    gan1 = presentar_resultados_list(resultados1, partidos)
    print "hay ", votantes_contentos(votantes, gan1, (len(partidos))/2 ), u"votantes contentos"
    raw_input()    

    print u"===== Resultados de metodo Borda modificado  exp ====="
    resultados2 = mi_eleccion_2(votantes)
    gan2 = presentar_resultados_list(resultados2, partidos)
    print "hay ", votantes_contentos(votantes, gan2, (len(partidos))/2 ), u"votantes contentos"
    raw_input()    

    print u"===== Resultados de metodo de Mayoritario ====="
    grafi = eleccion_grafi(votantes)
    resultado3 = resultado_grafica(grafi)
    print grafi
    print resultado3
    if type(resultado3) == int:
        print u" ganó el partido ", partidos[resultado3]
        print "hay ", votantes_contentos(votantes, partidos[resultado3].numero, (len(partidos))/2 ), u"votantes contentos"
    else:
        print u"falló al determinar ganador"


def sim_vot_al(opinions, partidos):
    numero = pregunta(u"¿Cúantos votantes quieres? ", int)
    votantes = n_votantes_al(numero, opinions, partidos)
    imprime_resultados(votantes,partidos)

def has_votantes_op(opinions,partidos):
    res = []
    end = 0
    print "Generando votantes"
    while end == 0:
        opinion = pregunta(u"¿que punto ideal quieres usar?", int)
        if opinion in opinions:
            num = pregunta(u"¿Cúantos votantes quieres generar?",int)
            for i in xrange(num):
                res.append(crear_votante_op(opinions, opinion, partidos, 0.20))
        else:
            print u"ese punto ideal no esta disponible"
        x = pregunta_sn(u"¿Terminar de agregar votantes? ")
        if x == "s":
            return res

def has_votantes_op_buena(opinions,partidos):
    res = []
    end = 0
    print "Generando votantes"
    while end == 0:
        opinion = pregunta(u"¿que punto ideal quieres usar?", int)
        if opinion in opinions:
            num = pregunta(u"¿Cúantos votantes quieres generar?",int)
            for i in xrange(num):
                res.append(crear_votante_op_buena(opinions, opinion, partidos, random.randrange(0,len(partidos))))
        else:
            print u"ese punto ideal no esta disponible"
        x = pregunta_sn(u"¿Terminar de agregar votantes? ")
        if x == "s":
            return res

def has_votantes_op_buena_en_intervalo(opinions,partidos):
    res = []
    end = 0
    print "Generando votantes"
    print u"se generarán votantes con puntos ideales en un intervalo dado, incluidos los extremos"
    while end == 0:
        ex1 = pregunta(u"¿Extremo inferior?", int)
        if ex1 in opinions:
            ex2 = pregunta(u"¿Extremo superior?", int)
            if ex2 in opinions and ex2 >= ex1:
                num = pregunta(u"¿Cuantos votantes quieres generar?",int)
                for i in xrange(num):
                    res.append(crear_votante_op_buena(opinions, random.randrange(ex1,ex2 + 1), partidos, random.randrange(0,len(partidos))))
            else:
                print u"ese punto no esta disponible"
        else:
            print u"ese punto no esta disponible"
        x = pregunta_sn(u"¿Terminar de agregar votantes? ")
        if x == "s":
            return res

def sim_definitiva():
    print u"Esta es una simulación de elecciones con el proposito de probar diferentes metodos de escrutinio, y permite probarlos con poblaciones de opinion variable"
    print u"Opciones: "
    print u"1) simulación con votantes totalmente aleatorios"
    print u"2) simulación con puntos ideales "
    print u"3) simulación con puntos ideales y votantes mas rigurosos "
    print u"4) simulación con puntos ideales y votantes mas rigurosos aleatorios por intervalos "
    sim = pregunta_op_mult("",range(1,5))
    if sim == 1:
        partidos = has_partidos_para_al()
        rep = pregunta(u"¿Cuantas repeticiones?", int)
        for i in xrange(rep):
            sim_vot_al([0,1], partidos)
    if sim == 2:
        opinions = has_opinions()
        partidos = has_partidos(opinions)
        votantes = has_votantes_op(opinions,partidos)
        imprime_resultados(votantes,partidos)
    if sim == 3:
        opinions = has_opinions()
        partidos = has_partidos(opinions)
        votantes = has_votantes_op_buena(opinions,partidos)
        imprime_resultados(votantes,partidos)
    if sim == 4:
        opinions = has_opinions()
        partidos = has_partidos(opinions)
        votantes = has_votantes_op_buena_en_intervalo(opinions,partidos)
        imprime_resultados(votantes,partidos)


### Funciones para simular sin Print ###

def print_votos(votantes):
    print "=============================="
    for votant in votantes:
            print votant.voto_estr, votant.voto_free

def sim_al_auto(num_votantes, num_partidos, num_rep):
    partidos =[]
    for i in xrange(num_partidos):
        partidos.append(partido(i,i))
    coincide = 0
    m_falla = 0
    m_fubar = 0
    for j in xrange(num_rep):
        votantes = n_votantes_al(num_votantes, range(len(partidos)) , partidos)
        grafi = eleccion_grafi(votantes)
        resultado3 = grafi_gan_intran(grafi)
        resultados4 = metodo_borda(votantes)
        res_borda = max_lis_key(resultados4)
        if res_borda == resultado3[2]:
            coincide = coincide + 1
#        else:
#            print_votos(votantes)
        if resultado3[1] == False:
            m_falla= m_falla+1
        if resultado3[0] == False:
            m_fubar = m_fubar+1
    print "coinciden: ", coincide
    print "mayoritario intrans: ", m_falla
    print "mayoritatio fubar: ", m_fubar
    print coincide,",",m_falla,",",m_fubar
    raw_input()


##########

sim_definitiva()

#sim_al_auto(100, 5, 100)

#for i in [6,7,8,9,10]:
#    for j in [3,4,5,10,100,1000]:
#        print [j,i]
#        sim_al_auto(j,i,100)
